/**
   składowe statyczne nie są traktowane jako stan klasy,
   można je modyfikować w metodach stałych.
 */
class Foo {
public:
	Foo(int v) : v_(v) {}

	const int& get() const {
		++V_; //modyfikacja składowej statycznej w metodzie stałej
		return v_;
	}
public:
	int v_;
	static int V_;
};

int Foo::V_ = 10;

#include <iostream>

int main() {
	const Foo f(1);
	std::cout << f.get() << std::endl;
	std::cout << Foo::V_ << std::endl;
	return 0;
}
