#include <string>
#include <iostream>
#include <boost/compute/core.hpp>

using namespace std;

std::string device_type_str(const boost::compute::device& d) {
	std::string type_str;
	if(d.type() & boost::compute::device::gpu)
		type_str += "GPU";
	if(d.type() & boost::compute::device::cpu)
		type_str += "CPU";
	if(d.type() & boost::compute::device::accelerator)
		type_str += "ACCELERATOR";

	return type_str;
}

int main() {
	for( boost::compute::platform p : boost::compute::system::platforms() ) {
		cout << "Platform : " << p.name() << endl;
		for( boost::compute::device d : p.devices() ) {
			cout << "\tDevice, id:" << d.id()
				 << ", type:" << device_type_str( d )
				 << ", name:" << d.name()
				 << ", vendor:" << d.vendor()
				 << ", compute units:" << d.compute_units()
				 << ", clock freq:" << d.clock_frequency()
				 << endl;
		}
	}
	return 0;
}

