#include <iostream>
#include <chrono>
#include <thread>
#include <mutex>

using namespace std;

mutex io_mutex; // mutex do synchronizacji z iostream

class MyThread {
public:
	MyThread() : finish_(false) {}
	void finish() { finish_ = true; }
	void operator()() {
		while(!finish_) {
			this_thread::sleep_for(chrono::seconds(1));
			lock_guard<mutex> lock(io_mutex);
			cout << "." << flush;
		}
		lock_guard<mutex> lock(io_mutex);
		cout << " przerwano" << endl;
	}
private:
	volatile bool finish_;
};
int main() {
	MyThread my_thread;
    thread thrd( ref(my_thread) );
	{
		lock_guard<mutex> lock(io_mutex);
		cout << "uruchomiony watek uzytkownika" << endl;
	}
	this_thread::sleep_for(chrono::seconds(6));
	{
		lock_guard<mutex> lock(io_mutex);
		cout << "zadanie przerwania" << endl;
	}
	my_thread.finish();
	if(thrd.joinable()) {
		thrd.join();
	}
	{
		lock_guard<mutex> lock(io_mutex);
		cout << "zakonczony watek uzytkownika" << endl;
	}
    return 0;
}



