#include <iostream>
#include <istream>
#include <ostream>
#include <string>
#include <boost/asio.hpp>

using namespace boost::asio;

int main()
{
  try
  {
    io_service io_service;

	ip::tcp::resolver resolver(io_service);
	ip::tcp::resolver::query query("127.0.0.1", "http");
	ip::tcp::resolver::iterator endpoint = resolver.resolve(query);

    // ustanawia połączenie
	ip::tcp::socket socket(io_service);
	socket.connect(*endpoint);

	// zapytanie
    streambuf request;
    std::ostream request_stream(&request);
    request_stream << "GET index.html HTTP/1.0\r\n"
				   << "Host: localhost\r\n"
				   << "Accept: */*\r\n"
				   << "Connection: close\r\n\r\n";

    // wysyła
    write(socket, request);

    // odczytuje odpowiedź
    streambuf response;
    read_until(socket, response, "\r\n");
	std::cout << &response;
  }
  catch (std::exception& e)
  {
    std::cout << "Exception: " << e.what() << "\n";
  }

  return 0;
}
